<?php   
    ##############################################################
    # Name: class.paycall.php                                    #
    # File Description:                                          #
    # Author: Paycall                                            #
    # Web: http://www.paycall.co.il/                             #
    # Update: 2012-12-20                                         #
    #                                                            #
    # Discription:                                               #
    #                                                            #
    # NOTE: Changing the object can cause malfunctions and       #
    # disruptions in the clearing process.                       #
    ##############################################################
   
    define("WS_POST", 0);
    define("WS_GET" , 1);

    class Paycall{

        static private $server          = "http://admin.paycall.co.il/ws.php"; # paycall server       
        
        static function verifiedTransaction($transactionID, $businessCode, $CodeID = NULL){
            if(empty($transactionID) && !is_numeric($transactionID)){
                self::setLog("Error - Transaction ID is invalis !");
                return false;
            } 

            $queryArray = array(
                        "service" => "chckTrans",
                        "tId" => $transactionID, 
                        "cId" =>  $businessCode,
            );       
            if($CodeID)         $queryArray["codeId"]   = $CodeID;  
                  
            echo $tmpxml = self::Get_URL(self::$server, WS_GET, http_build_query($queryArray));        

            if(self::getvaluebykey($tmpxml, "RESULT") == 'true'){
                return true;     
            }else{
                self::setLog("Error - PayCall Verified Transactions: " . self::getvaluebykey($tmpxml, "ERROR"));
                return false;
            }   
        }

        
        //Check if Request is coming from PayCall Hosts 
        static function checkRequest(array $additionalHosts = array()){
           
            $allowed_hosts = array('31.222.136.9' , '184.106.181.157');
            $allowed_hosts = array_merge($allowed_hosts,$additionalHosts);
            
            if (!isset($_SERVER['REMOTE_ADDR']) || !in_array($_SERVER['REMOTE_ADDR'], $allowed_hosts)) {
                self::setLog("Error: Request from unauthorized Host " . $_SERVER['REMOTE_ADDR']);  
                return false;
            } 
            return true;   
        }
  
        
        static function setLog($data, $dir = NULL){
 
            $logDir = $dir ? $dir : dirname(__FILE__)."/logs/";
            $logFilePrefix = "paycall_log_";
            $date = date("Y-m-d H:i:s");
            
            //Check if directory exists, if not create new directory
            if(!is_dir($logDir)){
                if(!@mkdir($logDir, 0755, true))
                    return false;
            }
            
            //Open log file, if file doesn't exist create it
            $myFile = $logDir . $logFilePrefix .date("Y_m").".txt";
            $fh = @fopen($myFile, 'a+');
            if(!$fh){
                return false;    
            }
            
            fwrite($fh, "[".$date."]\n");
            fwrite($fh, $data."\n");
            fwrite($fh, "[".$date." - END LOG]\n\n");

            fclose($fh);
            
            return true;    
        }

        // Get_URL open http request the connection using POST or GET 
        static function Get_URL($url, $wsMethod=WS_GET ,$argQuery = "")
        {
             if($wsMethod == WS_GET){
                if(strpos($url,"?") !== false) 
                    $url = $url."&".$argQuery;
                else
                    $url = $url."?".$argQuery; 
            } 
                   
            if (function_exists('curl_init')==true){
                
                $ch = curl_init() or $this->error=curl_error();
                curl_setopt($ch, CURLOPT_URL,$url);
                if($wsMethod==WS_POST){ //use POST method
                    curl_setopt($ch, CURLOPT_POST,1);
                    curl_setopt($ch, CURLOPT_POSTFIELDS,$argQuery);
                }
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                $data=curl_exec($ch);
                curl_close($ch);
            }else{
                if($wsMethod==WS_GET){  //use GET method
                    $file = fopen ($url, "r");
                    if(!$file){
                        $this->error="Unable to open remote file.";
                        exit;
                    }
                    while(!feof($file))
                        $data .= fgets($file, 64);
                
                    fclose($file);
                }else{ //use POST method
                    $opts = array('http' =>
                        array(
                            'method'  => 'POST',
                            'header'  => 'Content-type: application/x-www-form-urlencoded',
                            'content' => $argQuery
                            )
                        ); 
                    $context = stream_context_create($opts);
                    $file = fopen ($url, "r",false,$context);
                    if(!$file){
                        $this->error="Unable to open remote file.";
                        exit;
                    }
                    while(!feof($file))
                        $data .= fgets($file, 64);
                   
                    fclose($file);       
                }
            }  
            return $data; 
        }#-#Get_URL()

        // $this->getvaluebykey base xml parser 
        static function getvaluebykey($string, $key)
        {
            $start="<$key>";
            $end="</$key>";
            $string = " ".$string;
            $ini = strpos($string,$start);
            if ($ini == 0) return "";
            $ini += strlen($start);
            $len = strpos($string,$end,$ini) - $ini;
            return substr($string,$ini,$len);
        }#-#$this->getvaluebykey()    
    }

?>
